package AdventCalendarNotifier::CMS;

use strict;

use CGI;
use LWP::UserAgent;
use HTML::TreeBuilder;
use Time::Local;
use utf8;

sub date_diff {
    my($year1, $mon1, $mday1, $year2, $mon2, $mday2) = @_;
    return((timelocal(0, 0, 0, $mday2, $mon2 - 1, $year2 - 1900) -
            timelocal(0, 0, 0, $mday1, $mon1 - 1, $year1 - 1900)) / (24 * 60 * 60));
}

sub notify {
    my $cb = shift;
    my ( $loop_notification_dashboard ) = @_;

    my $plugin = MT->component("AdventCalendarNotifier");
    my $url = $plugin->get_config_value('url') || 'http://www.adventar.org/calendars/92/';
    my $title = $plugin->get_config_value('title') || 'Advent Calendar Movable Type';

    my $start = $plugin->get_config_value('start');
    my @start_date = split(/-/, $start);
    my $end = $plugin->get_config_value('end');
    my @end_date = split(/-/, $end);

    my ( $sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst ) = localtime(time);
    $year += 1900;
    $mon += 1;

    return if !(date_diff($start_date[0], $start_date[1], $start_date[2], $year, $mon, $day) >= 0 &&
                date_diff($year, $mon, $day, $end_date[0], $end_date[1], $end_date[2]) >= 0);

    my $q = new CGI();
    my $ua = LWP::UserAgent->new();
    my $res = $ua->get($url);

    my $tree = HTML::TreeBuilder->new;
    $tree->parse($res->content);

    my $data = '';
    my $result_url;
    my $result_title;
    for my $tag1 ( $tree->look_down("class", "mod-entryList-body") ){
        for my $tag2 ( $tag1->look_down("class", "mod-entryList-url") ) {
            $result_url = $tag2->as_text if  $tag2->as_text =~ /http/;
        }
        for my $tag2 ( $tag1->look_down("class", "mod-entryList-title") ) {
            $result_title = $tag2->as_text if  $tag2->as_text ne '';
            utf8::decode($result_title);
        }
    }
    $data = '<a href="' . $result_url . '" target="_blank">' . $result_title . '</a>';

    my $plugin = MT->component('AdventCalendarNotifier');
    my @notifications = (
        {
            level  => 'success',
            text   => $title,
            detail => $data,
        },
    );
    push @{ $loop_notification_dashboard }, @notifications;
}
 
1;
